-- Better Fang pop-gun - From "Simple character rebalancing" by TehRealSalt

local function newGunLook(player) 
	if (true)
		-- I really like this code tweak,
		-- as it gives more oppritunities for cool big chains,
		-- but the span stuff breaks in Lua
		-- so we're back to vanilla targetting
		return P_LookForEnemies(player, false, true)
	end

	local ringdist = RING_DIST*2
	local span = ANG30

	if (player.quickdrawchain > 0)
		ringdist = $1 + ((RING_DIST/3) * player.quickdrawchain)
		if (ringdist > RING_DIST*4)
			ringdist = RING_DIST*4
		end

		--[[
		span = $1 + (ANG10 * player.quickdrawchain)
		if (span > ANG60)
			span = ANG60
		end
		--]]
	end

	local maxdist = FixedMul(ringdist, player.mo.scale)
	local closestdist = 0
	local closestmo = nil
	local nonenemiesdisregard = MF_SPRING

	for mo in mobjs.iterate()
		if (mo.flags & MF_NOCLIPTHING) continue end
		if (mo.health <= 0) continue end -- dead

		if (!((mo.flags & (MF_ENEMY|MF_BOSS|MF_MONITOR)
		and (mo.flags & MF_SHOOTABLE)) or (mo.flags & MF_SPRING)) == !(mo.flags2 & MF2_INVERTAIMABLE)) -- allows if it has the flags desired XOR it has the invert aimable flag
			continue -- not a valid target
		end

		if (mo == player.mo) continue end
		if (mo.flags2 & MF2_FRET) continue end
		if (mo.flags & nonenemiesdisregard) continue end
		if (mo.type == MT_PLAYER) continue end -- Don't chase after other players!

		local zdist = (player.mo.z + player.mo.height/2) - (mo.z + mo.height/2)
		local dist = P_AproxDistance(player.mo.x-mo.x, player.mo.y-mo.y)

		if ((R_PointToAngle2(0, 0, dist, zdist) + span) > span*2)
			continue -- Don't home outside of desired angle!
		end

		dist = P_AproxDistance(dist, zdist);
		if (dist > maxdist)
			continue -- out of range
		end

		if ((twodlevel or player.mo.flags2 & MF2_TWOD)
		and abs(player.mo.y-mo.y) > player.mo.radius)
			continue -- not in your 2d plane
		end

		if ((closestmo and closestmo.valid) and (dist > closestdist))
			continue
		end

		if (((R_PointToAngle2(
				player.mo.x + P_ReturnThrustX(player.mo, player.mo.angle, player.mo.radius),
				player.mo.y + P_ReturnThrustY(player.mo, player.mo.angle, player.mo.radius),
				mo.x, mo.y
			) - player.mo.angle) + span) > span*2)
			continue -- behind back
		end

		if not (P_CheckSight(player.mo, mo))
			continue -- out of sight
		end

		closestmo = mo
		closestdist = dist
	end

	return closestmo
end

local function zpos(posmo, item)
	return (posmo.z + (posmo.height - mobjinfo[item].height)/2)
end

local function newGunslinger(player)
	local onground = P_IsObjectOnGround(player.mo)

	local canstand = true
	if (player.mo.standingslope and player.mo.standingslope.valid)
		if not (player.mo.standingslope.flags & SL_NOPHYSICS)
		and not (abs(player.mo.standingslope.zdelta) < FRACUNIT/2)
			canstand = false
		end
	end

	if not ((player.pflags & PF_SLIDING) or (player.exiting) or (P_PlayerInPain(player)))
	and not (player.weapondelay)
	and (canstand and onground)
		-- Same code as vanilla, but without the clause for speed.
		-- You naturally lose your speed via friction.
		-- Also allows for gun target chaining, as long as you don't miss.
		-- (As I like to call it: quick draw!)

		local lockon = newGunLook(player)
		if (lockon and lockon.valid)
			P_SpawnLockOn(player, lockon, mobjinfo[MT_LOCKON].spawnstate)
		end

		if (player.cmd.buttons & BT_USE)
		and not (player.gunheld)
			local bullet = nil

			player.mo.state = S_PLAY_FIRE
			player.panim = PA_ABILITY2
 
			if (lockon and lockon.valid)
				player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, lockon.x, lockon.y)
				bullet = P_SpawnPointMissile(
					player.mo,
					lockon.x, lockon.y, zpos(lockon, player.revitem),
					player.revitem,
					player.mo.x, player.mo.y, zpos(player.mo, player.revitem)
				)

				player.quickdrawchain = $1+1
				player.scoreadd = player.quickdrawchain-1
				player.quickdrawexpire = TICRATE/2

				-- Short cooldown if you're chaining properly!
				player.guntics = 5
				player.weapondelay = 7
			else
				bullet = P_SpawnPointMissile(
					player.mo,
					player.mo.x + P_ReturnThrustX(nil, player.mo.angle, FRACUNIT),
					player.mo.y + P_ReturnThrustY(nil, player.mo.angle, FRACUNIT),
					zpos(player.mo, player.revitem),
					player.revitem,
					player.mo.x, player.mo.y, zpos(player.mo, player.revitem)
				)

				if (bullet and bullet.valid)
					bullet.flags = $1 & ~MF_NOGRAVITY
					bullet.momx = $1 / 2
					bullet.momy = $1 / 2
				end

				
				player.quickdrawchain = 0
				player.scoreadd = 0
				player.quickdrawexpire = 0

				-- Long cooldown if you have a bad shot
				--player.guntics = 15
				player.guntics = 5
				player.weapondelay = 7 -- 17
			end

			player.drawangle = player.mo.angle
			player.gunheld = true
		end
	end
end

addHook("MobjThinker", function(mo)
	if (mo.player and mo.player.valid)
		local player = mo.player
		if (player.charability2 == CA2_GUNSLINGER)
			if (player.quickdrawchain == nil)
				player.quickdrawchain = 0
			end

			if (player.quickdrawexpire == nil)
				player.quickdrawexpire = 0
			end

			if (player.gunheld == nil)
				player.gunheld = false
			end

			if (player.guntics == nil)
				player.guntics = 0
			end

			if (player.panim == PA_ABILITY2)
				if (player.quickdrawchain > 0)
					player.scoreadd = player.quickdrawchain-1
					player.quickdrawexpire = TICRATE/2
				end

				if (player.mo.state == S_PLAY_FIRE_FINISH)
				and (player.guntics > 0)
					player.mo.tics = player.guntics
					player.guntics = 0
				end
			else
				if (player.quickdrawexpire > 0)
					-- Mercy period to keep your score chain
					player.quickdrawexpire = $1 - 1
				else
					player.quickdrawchain = 0
				end
			end

			if not (player.cmd.buttons & BT_USE)
				player.gunheld = false
			end

			newGunslinger(player)
		end
	end
end, MT_PLAYER)

addHook("SpinSpecial", function(player)
	if (player.charability2 == CA2_GUNSLINGER)
		-- due to order of operations, newGunslinger cannot be used here
		return true
	end
end)
