freeslot("MT_DASHPANEL", "S_DASHPANEL", "S_DASHPANELINVIS", "sfx_jsdash", "SPR_DASH")
--{Lock Movement, NULL, Invisible}
mobjinfo[MT_DASHPANEL] = {
	//$Title Dash Panel
	//$Sprite ZBDASHPANEL
	//$Category JanaMapTools
	//$Arg0 Flags
	//$Arg0Type 12
	//$Arg0Enum {1 = "Lock Movement";4 = "Invisible";}
	//$Arg1 Speed
	//$Arg1ToolTip In fracunits
	//$Arg1Type 0
	//$FlatSprite true
	//$Flags1Text Lock Movement
	//$Flags4Text Invisible
	//$ParameterText Speed
	doomednum = 4095,
	spawnstate = S_DASHPANEL,
	spawnhealth = 1,
	speed = 10,
	radius = 32*FRACUNIT,
	height = 1*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 36*FRACUNIT,
	flags = MF_SPECIAL--|MF_SPRING
}

states[S_DASHPANEL] = {
	sprite = SPR_DASH,
	frame = FF_FLOORSPRITE|FF_ANIMATE|A,
	tics = 16,
	var1 = 7,
	var2 = 1,
	nextstate = S_DASHPANEL
}

states[S_DASHPANELINVIS] = {
	sprite = SPR_DASH,
	frame = FF_FLOORSPRITE|FF_ANIMATE|A,
	tics = 16,
	var1 = 7,
	var2 = 1,
	nextstate = S_DASHPANELINVIS
}

local function MovePlayer(playermo, object2) --From SRB2 Source Code
	// Horizontal springs teleport you in FRONT of them.
	--playermo.momx = 0
	--playermo.momy = 0

	// Overestimate the distance to position you at
	local offx = P_ReturnThrustX(object2, object2.angle, (object2.radius + playermo.radius + 1) * 2)
	local offy = P_ReturnThrustY(object2, object2.angle, (object2.radius + playermo.radius + 1) * 2)
	local offz = object2.height/2
	
	// Make it square by clipping
	if offx > (object2.radius + playermo.radius + 1)
		offx = object2.radius + playermo.radius + 1
	elseif offx < -(object2.radius + playermo.radius + 1)
		offx = -(object2.radius + playermo.radius + 1)
	end
	if offy > (object2.radius + playermo.radius + 1)
		offy = object2.radius + playermo.radius + 1
	elseif offy < -(object2.radius + playermo.radius + 1)
		offy = -(object2.radius + playermo.radius + 1)
	end
	
	// Set position!
	if playermo.player.jmtwarptofront
		P_TryMove(playermo, object2.x + offx, object2.y + offy, true)
		playermo.player.jmtwarptofront = false
		playermo.player.jmtwarptoobject = nil
	elseif playermo.player.jmtwarptomiddle
		P_MoveOrigin(playermo, object2.x, object2.y, object2.z + ((object2.height)/2))
		playermo.player.jmtwarptomiddle = false
		playermo.player.jmtwarptoobject = nil
	elseif playermo.player.jmtwarptofront3d
		P_MoveOrigin(playermo, object2.x + offx, object2.y + offy, object2.z + offz)
		playermo.player.jmtwarptofront3d = false
		playermo.player.jmtwarptoobject = nil
	elseif playermo.player.jmtwarptofronttop
		P_MoveOrigin(playermo, object2.x + offx, object2.y + offy, object2.z + object2.height)
		playermo.player.jmtwarptofronttop = false
		playermo.player.jmtwarptoobject = nil
	elseif playermo.player.jmtwarptotop
		P_MoveOrigin(playermo, object2.x, object2.y, object2.z + object2.height)
		playermo.player.jmtwarptotop = false
		playermo.player.jmtwarptoobject = nil
	elseif playermo.player.jmtwarptofrontring
		if object2.jmtpitch > ANGLE_45
			P_MoveOrigin(playermo, object2.x + FixedMul(offx, cos(object2.jmtpitch)), object2.y + FixedMul(offy, cos(object2.jmtpitch)), object2.z + object2.height + playermo.height)
		elseif object2.jmtpitch < ANGLE_45
			P_MoveOrigin(playermo, object2.x + offx, object2.y + offy, object2.z + FixedMul(object2.height, sin(object2.jmtpitch)))
		elseif object2.jmtpitch == ANGLE_45
			P_MoveOrigin(playermo, object2.x + offx, object2.y + offy, object2.z + object2.height)
		end
		playermo.player.jmtwarptofrontring = false
		playermo.player.jmtwarptoobject = nil
	end
end

addHook("TouchSpecial", function(dashmo, playermo)
	if playermo.player.dashlocktemp > 0 and not playermo.player.dashlock then return true end
	if not P_IsObjectOnGround(playermo) then return true end
	playermo.angle = dashmo.angle
	playermo.dashangle = dashmo.angle
	if udmf
		if dashmo.spawnpoint.args[0] & MTF_EXTRA
			playermo.player.dashlock = true
		else
			playermo.player.dashlock = false
		end
	else
		if dashmo.spawnpoint.options & MTF_EXTRA
			playermo.player.dashlock = true
		else
			playermo.player.dashlock = false
		end
	end
	playermo.state = S_PLAY_RUN
	playermo.player.dashlocktemp = 10
	if udmf == false
		playermo.player.dashpanelspeed = (dashmo.spawnpoint.extrainfo + 1) *20*FRACUNIT
	elseif udmf == true
		playermo.player.dashpanelspeed = dashmo.spawnpoint.args[1]*FRACUNIT
	else
		playermo.player.dashpanelspeed = 20*FRACUNIT
	end
	playermo.player.jmtwarptofront = true
	playermo.player.jmtwarptoobject = dashmo
	if not P_IsObjectOnGround(playermo)
		P_Thrust(playermo, playermo.dashangle, playermo.player.dashpanelspeed)
	else
		P_InstaThrust(playermo, playermo.dashangle, playermo.player.dashpanelspeed)
	end
	S_StartSound(dashmo, sfx_jsdash)
	return true
end, MT_DASHPANEL)

addHook("PlayerThink", function(player)
	player.dashlock = $ or 0
	player.dashlocktemp = $ or 0
	player.dashramplock = $ or 0
	player.springlock = $ or 0
	player.jmtrringsparkleticks = $ or 0
	if player.jmtwarptoobject
		MovePlayer(player.mo, player.jmtwarptoobject)
	end
	if player.dashlock == true or player.dashlocktemp > 0
		player.mo.angle = player.mo.dashangle
		player.drawangle = player.mo.dashangle
		--print(player.dashpanelspeed/FRACUNIT)
		player.powers[pw_noautobrake] = 1
		if player.mo.skin ~= "modernsonic"
			player.powers[pw_nocontrol] = 1
		else
			player.cmd.forwardmove = 0
			player.cmd.sidemove = 0
			player.cmd.buttons = $&!BT_JUMP
		end
		if P_IsObjectOnGround(player.mo)
			--print("On ground")
			P_InstaThrust(player.mo, player.mo.dashangle, player.dashpanelspeed)
		else
			--print("Not on ground")
			P_InstaThrust(player.mo, player.mo.dashangle, player.dashpanelspeed)
		end
	end
	if player.dashlocktemp > 0
		player.dashlocktemp = $ - 1
	end
	if player.jmtrringsparkleticks > 0
		for i = 1,2 do
			local sparkle = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-50, 50)*FRACUNIT, P_RandomRange(-50, 50)*FRACUNIT, P_RandomRange(-50, 50)*FRACUNIT, MT_IVSP)
		end
		local ghost = P_SpawnGhostMobj(player.mo)
		ghost.colorize = true
		player.jmtrringsparkleticks = $ - 1
	end
	if player.springlock > 0
		local horizMom = FixedMul(player.springspeed, cos(player.springzangle))
		local vertiMom = FixedMul(player.springspeed, sin(player.springzangle))
		P_InstaThrust(player.mo, player.mo.angle, horizMom)
		P_SetObjectMomZ(player.mo, vertiMom, false)
		player.springlock = $ - 1
	end
end)

/*addHook("PlayerCmd", function(player, cmd)
	if player.dashlock == true
		cmd.angleturn = player.mo.angle>>16
		cmd.forwardmove = 50
		cmd.sidemove = 0
		cmd.buttons = 0
	elseif player.dashlocktemp > 0
		cmd.angleturn = player.mo.angle>>16
		cmd.forwardmove = 50
		cmd.sidemove = 0
		cmd.buttons = 0
	end
end)*/

addHook("MapThingSpawn", function(mobj, mapthing)
	mobj.renderflags = $ | RF_OBJECTSLOPESPLAT | RF_NOSPLATBILLBOARD
	P_CreateFloorSpriteSlope(mobj)
	P_TryMove(mobj, mobj.x, mobj.y, false)
	if udmf
		if mapthing.args[0] & MTF_OBJECTSPECIAL
			mobj.flags2 = $|MF2_DONTDRAW
		end
	else
		if mapthing.options & MTF_OBJECTSPECIAL
			mobj.flags2 = $|MF2_DONTDRAW
		end
	end
	--mobj.scale = 2*FRACUNIT
end, MT_DASHPANEL)