freeslot("MT_DASHRAMP", "S_DASHRAMP", "sfx_jsdshr", "SPR_DRMP", "MT_DASHRAMPDECO", "S_DASHRAMPDECOA", "S_DASHRAMPDECOB")

mobjinfo[MT_DASHRAMP] = {
	//$Title Dash Ramp
	//$Sprite ZBDASHRAMP
	//$Category JanaMapTools
	//$Arg0 Flags
	//$Arg0Type 12
	//$Arg0Enum {1 = "Lock Control";2 = "Flip";4 = "Double Horizontal Force";}
	//$Arg1 Launch Speed
	//$Arg1ToolTip in Fracunits of thrust
	//$Arg1Type 0
	//$Flags1Text Lock Control
	//$Flags4Text Double Horizontal Force
	//$ParameterText Speed
	doomednum = 4093,
	spawnstate = S_DASHRAMP,
	spawnhealth = 1,
	speed = 10,
	radius = 32*FRACUNIT,
	height = 32*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 0,
	flags = MF_SPECIAL
}

states[S_DASHRAMP] = {
	sprite = SPR_DRMP,
	frame = FF_FLOORSPRITE|FF_ANIMATE|A,
	tics = 13,
	var1 = 12,
	var2 = 1,
	nextstate = S_DASHRAMP
}

mobjinfo[MT_DASHRAMPDECO] = {
	doomednum = -1,
	spawnstate = S_DASHRAMPDECOA,
	spawnhealth = 1,
	speed = 10,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 0,
	flags = MF_PAPERCOLLISION
}

states[S_DASHRAMPDECOA] = {
	sprite = SPR_DRMP,
	frame = FF_PAPERSPRITE|FF_ANIMATE|N,
	tics = 24,
	var1 = 11,
	var2 = 2,
	nextstate = S_DASHRAMPDECOA
}

states[S_DASHRAMPDECOB] = {
	sprite = SPR_DRMP,
	frame = FF_PAPERSPRITE|26,
	tics = -1,
	var1 = 7,
	var2 = 2,
	nextstate = S_DASHRAMPDECOB
}

addHook("TouchSpecial", function(drampmo, playermo)
	if playermo.player.jmtwarptoobject == drampmo then return true end
	if playermo.skin == "modernsonic"
		playermo.state = S_PLAY_AIRBOOST
	else
		playermo.state = S_PLAY_SPRING
	end
	playermo.angle = drampmo.angle
	playermo.dashangle = drampmo.angle
	playermo.player.jmtwarptofronttop = true
	playermo.player.jmtwarptoobject = drampmo

	local boostForce = drampmo.dashthrust
	local horizMom = boostForce
	local vertiMom = boostForce/2
	if playermo.skin == "modernsonic"
		if playermo.player.boosting == true
			vertiMom = $ + vertiMom/4
		end
		playermo.state = S_PLAY_AIRBOOST
	else
		playermo.state = S_PLAY_SPRING
	end
	--print(boostForce/FRACUNIT)
	
	if udmf
		if drampmo.spawnpoint.args[0] & MTF_OBJECTSPECIAL
			horizMom = $*2
		end
		if drampmo.spawnpoint.args[0] & MTF_OBJECTFLIP
			vertiMom = -$
		end
	else
		if drampmo.spawnpoint.options & MTF_OBJECTSPECIAL
			horizMom = $*2
		end
		if drampmo.spawnpoint.options & MTF_OBJECTFLIP
			vertiMom = -$
		end
	end
	playermo.player.dashlocktemp = 10
	playermo.player.dashpanelspeed = horizMom
	P_InstaThrust(playermo, drampmo.angle, horizMom)
	P_SetObjectMomZ(playermo, vertiMom, false)
	S_StartSound(drampmo, sfx_jsdshr)
	return true
end, MT_DASHRAMP)

local function UpdateDashRamp(mobj)
	local defaultpitch = (27*ANG1)+(5*ANG1/10)
	local slopezangle = 0
	local xoffset = 0
	local yoffset = 0
	local zoffset = 0
	if mobj.standingslope
		xoffset = FixedMul(FixedMul(45*FRACUNIT, cos(mobj.standingslope.zangle)),cos(mobj.angle))
		yoffset = FixedMul(FixedMul(45*FRACUNIT, cos(mobj.standingslope.zangle)),sin(mobj.angle))
		zoffset = mobj.z - P_GetZAt(mobj.standingslope, mobj.x - xoffset, mobj.y - yoffset, mobj.z)
		slopezangle = mobj.standingslope.zangle
	else
		xoffset = -FixedMul(45*FRACUNIT, cos(mobj.angle))
		yoffset = -FixedMul(45*FRACUNIT, sin(mobj.angle))
		zoffset = -46*FRACUNIT
	end
	mobj.flags2 = MF2_SPLAT
	mobj.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
	P_CreateFloorSpriteSlope(mobj)
	mobj.floorspriteslope.o = {
		x = mobj.x - xoffset,
		y = mobj.y - yoffset,
		z = mobj.z - zoffset
	}
	mobj.floorspriteslope.xydirection = mobj.angle
	mobj.floorspriteslope.zangle = defaultpitch + slopezangle
	mobj.jmtpitch = defaultpitch + slopezangle
	mobj.spriteyscale = abs(cos(slopezangle))
	mobj.defspriteyscale = mobj.spriteyscale
	
	mobj.lwall.rollangle = slopezangle
	mobj.rwall.rollangle = slopezangle
end


addHook("MapThingSpawn", function(mobj, mapthing)
	local defaultpitch = (27*ANG1)+(5*ANG1/10)
	mobj.jmtpitch = defaultpitch
	mobj.dashthrust = 20*FRACUNIT
	mobj.dashantigrav = false
	mobj.angle = mapthing.angle*ANG1
	if udmf == false
		mobj.dashthrust = (mapthing.extrainfo + 1) * (20*FRACUNIT)
	elseif udmf == true
		mobj.dashthrust = (mapthing.args[1]*FRACUNIT + 1)
	end
	
	local wallxoff = FixedMul(32*FRACUNIT, cos(mobj.angle+ANGLE_90)) 
	local wallyoff = FixedMul(32*FRACUNIT, sin(mobj.angle+ANGLE_90))
	
	local backxoff = FixedMul(45*FRACUNIT, cos(mobj.angle)) + FixedMul(4*FRACUNIT, cos(mobj.angle))
	local backyoff = FixedMul(45*FRACUNIT, sin(mobj.angle)) + FixedMul(4*FRACUNIT, sin(mobj.angle))
	
	mobj.lwall = P_SpawnMobjFromMobj(mobj, wallxoff + FixedMul(4*FRACUNIT, cos(mobj.angle)), wallyoff + FixedMul(4*FRACUNIT, sin(mobj.angle)), 0, MT_DASHRAMPDECO)
	mobj.rwall = P_SpawnMobjFromMobj(mobj, -wallxoff + FixedMul(4*FRACUNIT, cos(mobj.angle)), -wallyoff + FixedMul(4*FRACUNIT, sin(mobj.angle)), 0, MT_DASHRAMPDECO)
	mobj.bwall = P_SpawnMobjFromMobj(mobj, backxoff, backyoff, 0, MT_DASHRAMPDECO)

	mobj.bwall.state = S_DASHRAMPDECOB
	
	mobj.lwall.angle = mobj.angle
	mobj.rwall.angle = mobj.angle
	mobj.bwall.angle = mobj.angle + ANGLE_90
	
	if udmf
		
		if mapthing.args[0] & MTF_EXTRA
			mobj.lockedramp = true
		end
	else
		if mapthing.options & MTF_EXTRA
			mobj.lockedramp = true
		end
	end
	P_TryMove(mobj, mobj.x, mobj.y, false)
	P_TryMove(mobj.bwall, mobj.bwall.x, mobj.bwall.y, false)
	P_TryMove(mobj.lwall, mobj.lwall.x, mobj.lwall.y, false)
	P_TryMove(mobj.rwall, mobj.rwall.x, mobj.rwall.y, false)
	UpdateDashRamp(mobj)
	--print(mobj.jmtpitch)
	--mobj.scale = 2*FRACUNIT
end, MT_DASHRAMP)

addHook("MobjThinker", function(mobj)
	UpdateDashRamp(mobj)
end, MT_DASHRAMP)