freeslot("MT_DASHRING", "S_ORANGERING", "S_RAINBOWRING", "sfx_jsrrng", "sfx_jsorng", "SPR_ORNG", "SPR_RRNG")
--{1 = "Rainbow", 2 = "Flip", 3 = "Double Horizontal Force"}
mobjinfo[MT_DASHRING] = {
	//$Title Dash Ring
	//$Sprite ZBDASHRING
	//$Category JanaMapTools
	//$Arg0 Flags
	//$Arg0Type 12
	//$Arg0Enum {1 = "Rainbow";2 = "Half Vertical Force";4 = "Double Horizontal Force";}
	//$Arg1 Thrust
	//$Arg1ToolTip in Fracunits
	//$Arg1Type 0
	//$WallSprite true
	//$Flags1Text Rainbow
	//$Flags2Text DO NOT CHECK THIS
	//$Flags4Text Double Horizontal Force
	//$Flags8Text Half Vertical Force
	//$ParameterText Tilt
	doomednum = 4094,
	spawnstate = S_ORANGERING,
	spawnhealth = 1,
	speed = 10,
	radius = 64*FRACUNIT,
	height = 128*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 0,
	flags = MF_NOGRAVITY|MF_SPECIAL
}

states[S_ORANGERING] = {
	sprite = SPR_ORNG,
	frame = FF_ANIMATE|A,
	tics = 34,
	var1 = 16,
	var2 = 2,
	nextstate = S_ORANGERING
}

states[S_RAINBOWRING] = {
	sprite = SPR_RRNG,
	frame = FF_ANIMATE|A,
	tics = 32,
	var1 = 15,
	var2 = 2,
	nextstate = S_RAINBOWRING
}

local dashringscalelut = {8*FRACUNIT/10, 6*FRACUNIT/10, 4*FRACUNIT/10, 2*FRACUNIT/10, 0, 
						  2*FRACUNIT/10, 4*FRACUNIT/10, 6*FRACUNIT/10, 8*FRACUNIT/10, FRACUNIT}
dashringscalelut[0] = FRACUNIT

addHook("TouchSpecial", function(ringmo, playermo)
	if playermo.player.jmtwarptoobject == ringmo then return true end
	if playermo.skin == "modernsonic"
		playermo.state = S_PLAY_AIRBOOST
	else
		playermo.state = S_PLAY_SPRING
	end
	playermo.dashangle = ringmo.angle
	playermo.player.jmtwarptofrontring = true
	playermo.player.jmtwarptoobject = ringmo
	local horizMom = cos(ringmo.jmtpitch)*ringmo.boostforce
	local vertiMom = sin(ringmo.jmtpitch)*ringmo.boostforce
	
	if udmf
		if ringmo.spawnpoint.args[0] & MTF_OBJECTSPECIAL
			horizMom = $*2
		end
		if ringmo.spawnpoint.args[0] & MTF_OBJECTFLIP
			vertiMom = $/2
		end
	else
		if ringmo.spawnpoint.options & MTF_OBJECTSPECIAL
			horizMom = $*2
		end
		if ringmo.spawnpoint.options & MTF_AMBUSH
			vertiMom = $/2
		end
	end
	P_InstaThrust(playermo, ringmo.angle, horizMom)
	P_SetObjectMomZ(playermo, vertiMom, false)
	if ringmo.state == S_RAINBOWRING
		S_StartSound(ringmo, sfx_jsrrng)
		playermo.player.jmtrringsparkleticks = 35
		P_AddPlayerScore(playermo.player, 1000)
	else
		S_StartSound(ringmo, sfx_jsorng)
	end
	playermo.player.dashlocktemp = 10
	playermo.player.dashpanelspeed = horizMom
	ringmo.scalepulse = 10
	return true
end, MT_DASHRING)

addHook("MobjThinker", function(mobj)
	mobj.scalepulse = $ or 0
	if mobj.scalepulse >= 0
		local ghost = P_SpawnGhostMobj(mobj)
		ghost.color = SKINCOLOR_CLOUDY
		ghost.colorize = true
		ghost.fuse = 2
		mobj.spritexscale = dashringscalelut[mobj.scalepulse]
		mobj.spriteyscale = FixedMul(mobj.defspriteyscale, dashringscalelut[mobj.scalepulse])
		mobj.scalepulse = $-1
	end
end, MT_DASHRING)

addHook("MapThingSpawn", function(mobj, mapthing)
	mobj.jmtpitch = 0
	mobj.angle = mapthing.angle*ANG1
	mobj.boostforce = 30
	if udmf == false
		mobj.jmtpitch = (mapthing.extrainfo * (ANGLE_90/16))
		if mapthing.extrainfo == 0 then mobj.jmtpitch = ANGLE_90 end
	elseif udmf == true
		mobj.jmtpitch = (mapthing.pitch + 270)*ANG1
		mobj.jmtpitch = InvAngle($)
		mobj.boostforce = mapthing.args[1]
		if mapthing.args[1] == 0 then mobj.jmtpitch = ANGLE_90 end
	end
	local visualpitch = mobj.jmtpitch-ANGLE_90
	local nosplat = false
	if visualpitch == ANGLE_90 or visualpitch == ANGLE_270 then nosplat = true end
	if nosplat == false
		mobj.flags2 = MF2_SPLAT
		mobj.renderflags = RF_SLOPESPLAT|RF_NOSPLATBILLBOARD
		P_CreateFloorSpriteSlope(mobj)
		mobj.floorspriteslope.o = {
			x = mobj.x,
			y = mobj.y,
			z = mobj.z+(mobj.height/2)
		}
		mobj.floorspriteslope.xydirection = mobj.angle
		mobj.floorspriteslope.zangle = visualpitch
		mobj.spriteyscale = abs(cos(visualpitch))
		mobj.defspriteyscale = mobj.spriteyscale
	else
		mobj.renderflags = RF_PAPERSPRITE
		mobj.spriteyscale = FRACUNIT
		mobj.defspriteyscale = mobj.spriteyscale
	end
	if udmf
		if mapthing.args[0] & MTF_EXTRA
			mobj.state = S_RAINBOWRING
		end
	else
		if mapthing.options & MTF_EXTRA
			mobj.state = S_RAINBOWRING
		end
	end
	--print(mobj.jmtpitch)
	--mobj.scale = 2*FRACUNIT
end, MT_DASHRING)