freeslot("MT_PULLEYBASE", "S_PULLEYBASE", "MT_PULLEYROPE", "S_PULLEYROPE", "MT_PULLEYHANDLE", "S_PULLEYHANDLE", "sfx_jspuly", "SPR_PULY")

mobjinfo[MT_PULLEYBASE] = {
	//$Title Pulley
	//$Sprite ZBPULLYPREV
	//$Category JanaMapTools
	//$Arg0 Flags
	//$Arg0Type 12
	//$Arg0Enum {1 = "Inactive on Load";4 = "Invisible";}
	//$Arg1 Rope Length
	//$Arg1ToolTip In fracunits
	//$Arg1Type 0
	//$Flags1Text Inactive on Load
	//$Flags4Text Invisible
	//$ParameterText Length
	//$WallSprite true
	doomednum = 4091,
	spawnstate = S_PULLEYBASE,
	spawnhealth = 1,
	speed = 10,
	radius = 32*FRACUNIT,
	height = 1*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 0,
	flags = MF_NOCLIP|MF_NOGRAVITY
}

states[S_PULLEYBASE] = {
	sprite = SPR_PULY,
	frame = A,
	tics = -1,
	var1 = 7,
	var2 = 1,
	nextstate = S_PULLEYBASE
}

mobjinfo[MT_PULLEYROPE] = {
	doomednum = -1,
	spawnstate = S_PULLEYROPE,
	spawnhealth = 1,
	speed = 10,
	radius = 2*FRACUNIT,
	height = 1*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 0,
	flags = MF_NOCLIP|MF_NOGRAVITY
}

states[S_PULLEYROPE] = {
	sprite = SPR_PULY,
	frame = B,
	tics = -1,
	var1 = 7,
	var2 = 1,
	nextstate = S_PULLEYROPE
}

mobjinfo[MT_PULLEYHANDLE] = {
	doomednum = -1,
	spawnstate = S_PULLEYHANDLE,
	spawnhealth = 1,
	speed = 10,
	radius = 2*FRACUNIT,
	height = 1*FRACUNIT,
	dispoffset = 0,
	mass = 100,
	damage = 0,
	flags = MF_SPECIAL|MF_NOGRAVITY
}

states[S_PULLEYHANDLE] = {
	sprite = SPR_PULY,
	frame = C|FF_PAPERSPRITE,
	tics = -1,
	var1 = 7,
	var2 = 1,
	nextstate = S_PULLEYHANDLE
}

addHook("TouchSpecial", function(phandle, playermo)
	if playermo.player.pullyfollow == phandle then return true end
	if phandle.base.active == false then return true end
	playermo.state = S_PLAY_RIDE
	playermo.angle = phandle.base.angle - ANGLE_180
	phandle.hasplayer = true
	phandle.playergrabbed = playermo
	playermo.player.pullyfollow = phandle
	S_StartSound(phandle, sfx_jspuly)
	return true
end, MT_PULLEYHANDLE)

addHook("MobjThinker", function(mobj)
	-- Sanity checks
	if not (mobj and mobj.valid) then return end
	if not (mobj.base and mobj.base.valid) then return end
	if not (mobj.rope and mobj.rope.valid) then return end
	
	mobj.angle = mobj.base.angle + ANGLE_90
	if mobj.base.active == false
		mobj.movetype = "up"
	elseif mobj.hasplayer == true
		mobj.movetype = "up"
	elseif mobj.hasplayer == false
		mobj.movetype = "down"
	end
	if mobj.movetype
		if mobj.movetype == "up"
			if mobj.z < mobj.base.z - 48*FRACUNIT
				mobj.z = $ + 12*FRACUNIT
				if mobj.hasplayer == true
					mobj.playergrabbed.state = S_PLAY_RIDE
					P_MoveOrigin(mobj.playergrabbed, mobj.x, mobj.y, mobj.z -56*FRACUNIT)
					P_SetObjectMomZ(mobj.playergrabbed, 12*FRACUNIT)
				end
			elseif mobj.z >= mobj.base.z - 48*FRACUNIT
				mobj.z = mobj.base.z - 48*FRACUNIT
				if mobj.hasplayer == true
					P_MoveOrigin(mobj.playergrabbed, mobj.x, mobj.y, mobj.base.z)
					P_SetObjectMomZ(mobj.playergrabbed, 8*FRACUNIT)
					mobj.playergrabbed.state = S_PLAY_SPRING
					P_InstaThrust(mobj.playergrabbed, mobj.base.angle, -8*FRACUNIT)
					mobj.playergrabbed.player.pullyfollow = false
					mobj.playergrabbed = nil
					mobj.hasplayer = false
				end
			end
		elseif mobj.movetype == "down"
			if mobj.z > mobj.base.z - mobj.base.baselength - 48*FRACUNIT
				mobj.z = $ - 4*FRACUNIT
			elseif mobj.z <= mobj.base.z - mobj.base.baselength - 48*FRACUNIT
				mobj.z = mobj.base.z - mobj.base.baselength - 48*FRACUNIT
			end
		end
	end
	mobj.rope.length = mobj.base.z - mobj.z -48*FRACUNIT
	mobj.rope.spriteyscale = mobj.rope.length
	mobj.rope.spritexoffset = 2*FRACUNIT
	mobj.rope.renderflags = RF_ABSOLUTEOFFSETS--|RF_VERTICALFLIP
	P_MoveOrigin(mobj.rope, mobj.base.x, mobj.base.y, mobj.base.z)
end, MT_PULLEYHANDLE)

addHook("MapThingSpawn", function(mobj, mapthing)
	mobj.angle = mapthing.angle*ANG1
	mobj.rope = P_SpawnMobjFromMobj(mobj, 0, 0, 0, MT_PULLEYROPE)
	mobj.rope.base = mobj
	if udmf == false
		mobj.baselength = (mapthing.extrainfo + 1) * (64*FRACUNIT)
		mobj.rope.length = mobj.baselength
		mobj.active = true
	elseif udmf == true
		mobj.baselength = (mapthing.args[1]*FRACUNIT + 1)
		if mapthing.args[0] & MTF_EXTRA
			mobj.active = false
			mobj.rope.length = 0
		else
			mobj.active = true
			mobj.rope.length = mobj.baselength
		end
	end
	--mobj.rope.spriteyscale = mobj.rope.length
	
	mobj.handle = P_SpawnMobjFromMobj(mobj, 0, 0, -(mobj.rope.length + 48*FRACUNIT), MT_PULLEYHANDLE)
	mobj.handle.base = mobj
	mobj.handle.rope = mobj.rope
	mobj.rope.handle = mobj.handle
	mobj.handle.angle = mapthing.angle*ANG1
	mobj.handle.hasplayer = false
end, MT_PULLEYBASE)