-- Make pulleys give you rope hang (object-side)
local function pulleyHangTouch(phandle, playermo)
	local p = playermo.player
	p.pulleylasttic = true
	p.powers[pw_carry] = CR_ROPEHANG
	p.mo.flags = $ | MF_NOCLIP
	-- What if you die mid pulley?
end

addHook("TouchSpecial", pulleyHangTouch, MT_PULLEYHANDLE)

-- Make pulleys give you rope hang (player-side)
local function pulleyHangPlayer(p)
	if p.pulleylasttic and (p.mo.state != S_PLAY_RIDE
	or p.playerstate != PST_LIVE) then
		p.pulleylasttic = false
		p.powers[pw_carry] = CR_NONE
		p.mo.flags = $ & ~MF_NOCLIP
	end
end

addHook("PlayerThink", pulleyHangPlayer)

-- Remove remnants of allchars pulleys
local function allCharsPulley(mo)
	if mo and mo.valid then
		if not (mo.base and mo.base.valid) then
			P_RemoveMobj(mo.rope)
			P_RemoveMobj(mo)
		end
	end
end

addHook("MobjThinker", allCharsPulley, MT_PULLEYHANDLE)

-- Stop pulley handles from being papersprites
local function noPaperPulley(mo)
	if mo and mo.valid then
		mo.frame = $ & ~FF_PAPERSPRITE
	end
end

addHook("MobjSpawn", noPaperPulley, MT_PULLEYHANDLE)

-- Fix dash ring functionality
local function dashRingFix(special, toucher)
    if toucher and toucher.valid
	and special and special.valid
	and toucher.player then
		local p = toucher.player
		P_ResetPlayer(p)
		p.mo.state = S_PLAY_FALL
		if (p.pflags & PF_STARTJUMP) then p.pflags = $ & ~PF_STARTJUMP end
	end
end

addHook("TouchSpecial", dashRingFix, MT_DASHRING)