-- Script for defining Dry Lagoon stuff

-- Teleporter between Dry Lagoon areas
local function dlTeleport(p)
	if p and p.valid and mapheaderinfo[gamemap].lvlttl == "Dry Lagoon" then
		if p.mo.z < (-416 * FRACUNIT) then
			P_ResetPlayer(p)
			p.mo.state = S_PLAY_SPRING
			
			local newy = p.mo.y			
			if p.mo.y > 0 then
				newy = p.mo.y - (14720 * FRACUNIT)
				P_SetObjectMomZ(p.mo, 24 * FRACUNIT)
			else
				newy = p.mo.y + (14720 * FRACUNIT)
				P_SetObjectMomZ(p.mo, 16 * FRACUNIT)
			end
			local newz = p.mo.z + (32 * FRACUNIT)
			
			P_SetOrigin(p.mo, p.mo.x, newy, newz)
		end
	end
end

addHook("PlayerThink", dlTeleport)

freeslot("MT_DLLF", "S_DLLF", "SPR_DLLF")

states[S_DLLF] = {
	sprite = SPR_DLLF,
    frame = A,
	tics = -1,
	nextstate = S_DLLF
}

mobjinfo[MT_DLLF] = {
	--$Name Dry Lagoon Bush
	--$Category Dry Lagoon
	--$Sprite DLLFA0
	doomednum = 6461,
    spawnstate = S_DLLF,
    radius = 64 * FRACUNIT,
    height = 128 * FRACUNIT,
    flags = MF_SCENERY
}

freeslot("MT_DLPT", "S_DLPT", "SPR_DLPT")

states[S_DLPT] = {
	sprite = SPR_DLPT,
    frame = A,
	tics = -1,
	nextstate = S_DLPT
}

mobjinfo[MT_DLPT] = {
	--$Name Dry Lagoon Pot
	--$Category Dry Lagoon
	--$Sprite DLPTA1
	doomednum = 6462,
    spawnstate = S_DLPT,
    radius = 32 * FRACUNIT,
    height = 112 * FRACUNIT,
    flags = MF_SCENERY | MF_SOLID
}

freeslot("MT_DLTR", "S_DLTR", "SPR_DLTR")

states[S_DLTR] = {
	sprite = SPR_DLTR,
    frame = A,
	tics = -1,
	nextstate = S_DLTR
}

mobjinfo[MT_DLTR] = {
	--$Name Dry Lagoon Tree
	--$Category Dry Lagoon
	--$Sprite DLTRA0
	doomednum = 6463,
    spawnstate = S_DLTR,
    radius = 16 * FRACUNIT,
    height = 128 * FRACUNIT,
    flags = MF_SCENERY
}

freeslot("MT_DLBR", "S_DLBR", "SPR_DLBR")

states[S_DLBR] = {
	sprite = SPR_DLBR,
    frame = A,
	tics = -1,
	nextstate = S_DLBR
}

mobjinfo[MT_DLBR] = {
	--$Name Dry Lagoon Bramble
	--$Category Dry Lagoon
	--$Sprite DLBRA0
	doomednum = 6464,
    spawnstate = S_DLBR,
    radius = 32 * FRACUNIT,
    height = 128 * FRACUNIT,
    flags = MF_SCENERY
}