-- Script for defining Green Forest stuff

freeslot("MT_GFFOL1", "S_GFFOL1", "SPR_GFF1")

states[S_GFFOL1] = {
	sprite = SPR_GFF1,
    frame = A,
	tics = -1,
	nextstate = S_GFFOL1
}

mobjinfo[MT_GFFOL1] = {
	--$Name Forest Foliage 1
	--$Category Green Forest
	--$Sprite GFF1A0
	doomednum = 6362,
    spawnstate = S_GFFOL1,
    radius = 32 * FRACUNIT,
    height = 64 * FRACUNIT,
    flags = MF_SCENERY
}

freeslot("MT_GFFOL2", "S_GFFOL2", "SPR_GFF2")

states[S_GFFOL2] = {
	sprite = SPR_GFF2,
    frame = A,
	tics = -1,
	nextstate = S_GFFOL2
}

mobjinfo[MT_GFFOL2] = {
	--$Name Forest Foliage 2
	--$Category Green Forest
	--$Sprite GFF2A0
	doomednum = 6363,
    spawnstate = S_GFFOL2,
    radius = 32 * FRACUNIT,
    height = 64 * FRACUNIT,
    flags = MF_SCENERY
}

freeslot("MT_GFFOL3", "S_GFFOL3", "SPR_GFF3")

states[S_GFFOL3] = {
	sprite = SPR_GFF3,
    frame = A,
	tics = -1,
	nextstate = S_GFFOL3
}

mobjinfo[MT_GFFOL3] = {
	--$Name Forest Foliage 3
	--$Category Green Forest
	--$Sprite GFF3A0
	doomednum = 6364,
    spawnstate = S_GFFOL3,
    radius = 32 * FRACUNIT,
    height = 64 * FRACUNIT,
    flags = MF_SCENERY
}

freeslot("MT_GFFOL4", "S_GFFOL4", "SPR_GFF4")

states[S_GFFOL4] = {
	sprite = SPR_GFF4,
    frame = A,
	tics = -1,
	nextstate = S_GFFOL4
}

mobjinfo[MT_GFFOL4] = {
	--$Name Forest Foliage 4
	--$Category Green Forest
	--$Sprite GFF4A0
	doomednum = 6365,
    spawnstate = S_GFFOL4,
    radius = 32 * FRACUNIT,
    height = 64 * FRACUNIT,
    flags = MF_SCENERY
}

freeslot("MT_GFFOL5", "S_GFFOL5", "SPR_GFF5")

states[S_GFFOL5] = {
	sprite = SPR_GFF5,
    frame = A,
	tics = -1,
	nextstate = S_GFFOL5
}

mobjinfo[MT_GFFOL5] = {
	--$Name Forest Foliage 5
	--$Category Green Forest
	--$Sprite GFF5A0
	doomednum = 6366,
    spawnstate = S_GFFOL5,
    radius = 32 * FRACUNIT,
    height = 64 * FRACUNIT,
    flags = MF_SCENERY
}

freeslot("MT_GFFOL6", "S_GFFOL6", "SPR_GFF6")

states[S_GFFOL6] = {
	sprite = SPR_GFF6,
    frame = A,
	tics = -1,
	nextstate = S_GFFOL6
}

mobjinfo[MT_GFFOL6] = {
	--$Name Forest Foliage 6
	--$Category Green Forest
	--$Sprite GFF6A0
	doomednum = 6367,
    spawnstate = S_GFFOL6,
    radius = 32 * FRACUNIT,
    height = 64 * FRACUNIT,
    flags = MF_SCENERY
}

freeslot("MT_GFFOL7", "S_GFFOL7", "SPR_GFF7")

states[S_GFFOL7] = {
	sprite = SPR_GFF7,
    frame = A,
	tics = -1,
	nextstate = S_GFFOL7
}

mobjinfo[MT_GFFOL7] = {
	--$Name Forest Foliage 7
	--$Category Green Forest
	--$Sprite GFF7A0
	doomednum = 6368,
    spawnstate = S_GFFOL7,
    radius = 32 * FRACUNIT,
    height = 64 * FRACUNIT,
    flags = MF_SCENERY
}

-- Function to rotate objects on slopes
-- From Golden: https://mb.srb2.org/addons/sloperollangle-character-rotation-on-slopes.1188/
local function rotateObjectOnSlopes(mo)

	// Generic sanity checks.
	if not mo.subsector or not mo.subsector.valid
	or not mo.subsector.sector or not mo.subsector.sector.valid
	or not P_IsObjectOnGround(mo) then
		return
	end

	// Get the angle that we're looking from.
	local lookAngle = R_PointToAngle(mo.x, mo.y)

	-- Get the slope the object is on
	local slopesector = nil
	
	-- FOUR CASES: (why the fuck doesn't standingslope work)
	--    flip  floorrover  ceilingrover
	-- 1: No    No          N/A
	-- 2: No    Yes         N/A
	-- 3: Yes   N/A         No
	-- 4: Yes   N/A         Yes
	if not (mo.eflags & MFE_VERTICALFLIP) then
		if not mo.floorrover then
			slopesector = mo.subsector.sector.c_slope
		else
			slopesector = mo.floorrover.t_slope
		end
	else
		if not mo.ceilingrover then
			slopesector = mo.subsector.sector.f_slope
		else
			slopesector = mo.ceilingrover.b_slope
		end
	end

	-- Didn't find a slope?
	if not slopesector then return end
	
	// zangle and direction of the slope we're on (if any).
	local zangle = slopesector.zangle
	local xydirection = slopesector.xydirection
	
	// Flip the zangle too!
	if mo.eflags & MFE_VERTICALFLIP then
		zangle = InvAngle(zangle)
	end

	// Fancy angle math that rolls the sprite against the slope.
	// Trust me on this one.
	mo.rollangle = FixedMul(zangle, sin(lookAngle - xydirection))
end

addHook("MobjThinker", rotateObjectOnSlopes, MT_GFFOL1)
addHook("MobjThinker", rotateObjectOnSlopes, MT_GFFOL2)
addHook("MobjThinker", rotateObjectOnSlopes, MT_GFFOL3)
addHook("MobjThinker", rotateObjectOnSlopes, MT_GFFOL4)
addHook("MobjThinker", rotateObjectOnSlopes, MT_GFFOL5)
addHook("MobjThinker", rotateObjectOnSlopes, MT_GFFOL6)
addHook("MobjThinker", rotateObjectOnSlopes, MT_GFFOL7)

-- How much time do we have before Hawaii explodes?
local islandtimer = 8 * 60 * TICRATE

-- Thinker for the Hawaii timer; blow up the island once time is up
local function hawaiiThinker(p)
	if p and p.valid and mapheaderinfo[gamemap].lvlttl == "Green Forest" then
		if p.realtime == islandtimer then
			P_FlashPal(p, 4, 2 * TICRATE)
			S_StartSound(p.mo, sfx_bebomb)
			p.mo.momx = 0
			p.mo.momy = 0
			p.mo.momz = 10 * FRACUNIT
		elseif p.realtime == islandtimer + TICRATE then
			if p.lives > 1 then P_KillMobj(p.mo) end
			G_SetCustomExitVars(gamemap, 1)
			G_ExitLevel()
		elseif p.realtime > islandtimer then
			p.mo.state = S_PLAY_DEAD
			p.mo.momx = 0
			p.mo.momy = 0
		end
	end
end

addHook("PlayerThink", hawaiiThinker)

-- Function for displaying the Hawaii timer
local function hawaiiDisplay(v, p)
	if p and p.valid and mapheaderinfo[gamemap].lvlttl == "Green Forest" then
		local timeleft = islandtimer - p.realtime
		if timeleft < 0 then timeleft = 0 end
		
		local minsleft = G_TicsToMinutes(timeleft)
		local secsleft = G_TicsToSeconds(timeleft)
		local csecsleft = G_TicsToCentiseconds(timeleft)
		
		if string.len(secsleft) == 1 then secsleft = '0' .. tostring(secsleft) end
		if string.len(csecsleft) == 1 then csecsleft = tostring(csecsleft) .. '0' end
		
		local timestring = tostring(minsleft) .. ':' .. tostring(secsleft) .. '.' .. tostring(csecsleft)
		v.drawString(160, 180, timestring, V_PERPLAYER | V_ALLOWLOWERCASE | V_REDMAP, "center")
	end
end

hud.add(hawaiiDisplay)