-- Buff the fan speed in Radical Highway
local function rhFanRise(p)
	if p and p.valid and mapheaderinfo[gamemap].lvlttl == "Radical Highway" then
		if p.powers[pw_carry] == CR_FAN then
			P_SetObjectMomZ(p.mo, 5 * FRACUNIT, true)
		end
	end
end

addHook("PlayerThink", rhFanRise)

freeslot("MT_RHSIGN1", "S_RHSIGN1", "SPR_RHS1")

states[S_RHSIGN1] = {
	sprite = SPR_RHS1,
    frame = A | FF_PAPERSPRITE,
	tics = -1,
	nextstate = S_RHSIGN1
}

mobjinfo[MT_RHSIGN1] = {
	--$Name Radical Highway Sign 1
	--$Category Radical Highway
	--$Sprite RHS1A0
	doomednum = 6508,
    spawnstate = S_RHSIGN1,
    radius = 16 * FRACUNIT,
    height = 32 * FRACUNIT,
    flags = MF_SCENERY | MF_NOCLIP | MF_NOGRAVITY
}

freeslot("MT_RHSIGN2", "S_RHSIGN2", "SPR_RHS2")

states[S_RHSIGN2] = {
	sprite = SPR_RHS2,
    frame = A | FF_PAPERSPRITE,
	tics = -1,
	nextstate = S_RHSIGN2
}

mobjinfo[MT_RHSIGN2] = {
	--$Name Radical Highway Sign 2
	--$Category Radical Highway
	--$Sprite RHS2A0
	doomednum = 6509,
    spawnstate = S_RHSIGN2,
    radius = 16 * FRACUNIT,
    height = 32 * FRACUNIT,
    flags = MF_SCENERY | MF_NOCLIP | MF_NOGRAVITY
}

freeslot("MT_RHSIGN3", "S_RHSIGN3", "SPR_RHS3")

states[S_RHSIGN3] = {
	sprite = SPR_RHS3,
    frame = A | FF_PAPERSPRITE,
	tics = -1,
	nextstate = S_RHSIGN3
}

mobjinfo[MT_RHSIGN3] = {
	--$Name Radical Highway Sign 3
	--$Category Radical Highway
	--$Sprite RHS3A0
	doomednum = 6510,
    spawnstate = S_RHSIGN3,
    radius = 16 * FRACUNIT,
    height = 32 * FRACUNIT,
    flags = MF_SCENERY | MF_NOCLIP | MF_NOGRAVITY
}

freeslot("MT_RHSIGN4", "S_RHSIGN4", "SPR_RHS4")

states[S_RHSIGN4] = {
	sprite = SPR_RHS4,
    frame = A | FF_PAPERSPRITE,
	tics = -1,
	nextstate = S_RHSIGN4
}

mobjinfo[MT_RHSIGN4] = {
	--$Name Radical Highway Sign 4
	--$Category Radical Highway
	--$Sprite RHS4A0
	doomednum = 6511,
    spawnstate = S_RHSIGN4,
    radius = 16 * FRACUNIT,
    height = 32 * FRACUNIT,
    flags = MF_SCENERY | MF_NOCLIP | MF_NOGRAVITY
}

-- Radical Highway Blimp from OrdoMandalore

-- Sky beam light spawner
-- by Tatsuru, edited and updated by Ordomandalore, but Tat
-- deserves like 99% of the credit

freeslot("MT_SKYBEAM","S_BLMP")

mobjinfo[MT_SKYBEAM] = {
	--$Name Sky Beam Light
	--$Sprite BLMPA7
	doomednum = 2055,
	spawnstate = S_BLMP,
	radius = 16*FRACUNIT,
	height = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_SCENERY
}

addHook("MapThingSpawn", function(mo, mapt)
	mo.counter = mapt.options & MTF_OBJECTSPECIAL and 3*TICRATE/2 or 0
	mo.beamangle = FixedAngle(45*FRACUNIT)
	mo.beam = {}
	
	local dist = 0
	
	while mo.z - dist*FRACUNIT <= (mo.ceilingz)
		local x = FixedMul(dist * cos(mo.angle), cos(mo.beamangle))
		local y = FixedMul(dist * sin(mo.angle), cos(mo.beamangle))
		local z = dist * sin(mo.beamangle)
		
		local thok = P_SpawnMobjFromMobj(mo, x, y, z, MT_THOK)
		thok.tics = -1
		thok.color = SKINCOLOR_BLUE
		thok.scale = $ + dist * FRACUNIT/400 - FRACUNIT/3
		thok.flags = $ | MF_NOTHINK
		//thok.frame = $ | FF_TRANS20
		//thok.frame = $ | FF_FULLBRIGHT
		thok.blendmode = AST_ADD
		thok.dist = dist
		
		table.insert(mo.beam, thok)
		
		dist = $ + 50
	end
end, MT_SKYBEAM)

-- Beam thinker
addHook("MobjThinker", function(mo)
	mo.counter = $ + 1
	mo.beamangle = 6000 * sin(FixedAngle(mo.counter * FRACUNIT*3)) + ANGLE_45
	
	for _, t in ipairs(mo.beam)
		local x = mo.x + FixedMul(t.dist * cos(mo.angle), cos(mo.beamangle))
		local y = mo.y + FixedMul(t.dist * sin(mo.angle), cos(mo.beamangle))
		local z = mo.z - t.dist * sin(mo.beamangle)
		
		P_SetOrigin(t, x, y, z)
	end
end, MT_SKYBEAM)