-- Script for defining crate objects

freeslot("SPR_CBXS")
freeslot("MT_SA2CHAOBOX", "S_SA2CHAOBOX")

states[S_SA2CHAOBOX] = {
	sprite = SPR_NULL,
    frame = A,
	tics = -1,
	nextstate = S_SA2CHAOBOX
}

mobjinfo[MT_SA2CHAOBOX] = {
	--$Name Chao Crate
	--$Category SA2:Blast Objects
	--$Sprite CBXSA0
	--$arg0 Scaling Numerator
	--$arg1 Scaling Denominator
	doomednum = 6264,
    spawnstate = S_SA2CHAOBOX,
    radius = 64 * FRACUNIT,
    height = 128 * FRACUNIT,
    flags = MF_SOLID
}

freeslot("MT_SA2CHAOFACE", "S_SA2CHAOFACE")

states[S_SA2CHAOFACE] = {
	sprite = SPR_CBXS,
    frame = A,
	tics = -1,
	nextstate = S_SA2CHAOFACE
}

mobjinfo[MT_SA2CHAOFACE] = {
    spawnstate = S_SA2CHAOFACE,
    radius = 2 * FRACUNIT,
    height = 4 * FRACUNIT,
    flags = MF_NOGRAVITY | MF_NOCLIP
}

freeslot("SPR_WBXC", "SPR_WBXS", "SPR_WBXT")
freeslot("MT_SA2WOODBOX", "S_SA2WOODBOX")

states[S_SA2WOODBOX] = {
	sprite = SPR_NULL,
    frame = A,
	tics = -1,
	nextstate = S_SA2WOODBOX
}

mobjinfo[MT_SA2WOODBOX] = {
	--$Name Wooden Crate
	--$Category SA2:Blast Objects
	--$Sprite WBXSA0
	--$arg0 Scaling Numerator
	--$arg1 Scaling Denominator
	doomednum = 6231,
    spawnstate = S_SA2WOODBOX,
    radius = 64 * FRACUNIT,
    height = 128 * FRACUNIT,
    flags = MF_SOLID
}

freeslot("MT_SA2WOODFACE", "S_SA2WOODFACE")

states[S_SA2WOODFACE] = {
	sprite = SPR_WBXS,
    frame = A,
	tics = -1,
	nextstate = S_SA2WOODFACE
}

mobjinfo[MT_SA2WOODFACE] = {
    spawnstate = S_SA2WOODFACE,
    radius = 2 * FRACUNIT,
    height = 4 * FRACUNIT,
    flags = MF_NOGRAVITY | MF_NOCLIP
}

freeslot("SPR_MBXC", "SPR_MBXS", "SPR_MBXT")
freeslot("MT_SA2METALBOX", "S_SA2METALBOX")

states[S_SA2METALBOX] = {
	sprite = SPR_NULL,
    frame = A,
	tics = -1,
	nextstate = S_SA2METALBOX
}

mobjinfo[MT_SA2METALBOX] = {
	--$Name Metal Crate
	--$Category SA2:Blast Objects
	--$Sprite MBXSA0
	--$arg0 Scaling Numerator
	--$arg1 Scaling Denominator
	doomednum = 6232,
    spawnstate = S_SA2METALBOX,
    radius = 64 * FRACUNIT,
    height = 128 * FRACUNIT,
    flags = MF_SOLID
}

freeslot("MT_SA2METALFACE", "S_SA2METALFACE")

states[S_SA2METALFACE] = {
	sprite = SPR_MBXS,
    frame = A,
	tics = -1,
	nextstate = S_SA2METALFACE
}

mobjinfo[MT_SA2METALFACE] = {
    spawnstate = S_SA2METALFACE,
    radius = 2 * FRACUNIT,
    height = 4 * FRACUNIT,
    flags = MF_NOGRAVITY | MF_NOCLIP
}

freeslot("SPR_SBXC", "SPR_SBXS", "SPR_SBXT")
freeslot("MT_SA2STEELBOX", "S_SA2STEELBOX")

states[S_SA2STEELBOX] = {
	sprite = SPR_NULL,
    frame = A,
	tics = -1,
	nextstate = S_SA2STEELBOX
}

mobjinfo[MT_SA2STEELBOX] = {
	--$Name Steel Crate
	--$Category SA2:Blast Objects
	--$Sprite SBXSA0
	--$arg0 Scaling Numerator
	--$arg1 Scaling Denominator
	doomednum = 6268,
    spawnstate = S_SA2STEELBOX,
    radius = 64 * FRACUNIT,
    height = 128 * FRACUNIT,
    flags = MF_SOLID
}

freeslot("MT_SA2STEELFACE", "S_SA2STEELFACE")

states[S_SA2STEELFACE] = {
	sprite = SPR_SBXS,
    frame = A,
	tics = -1,
	nextstate = S_SA2STEELFACE
}

mobjinfo[MT_SA2STEELFACE] = {
    spawnstate = S_SA2STEELFACE,
    radius = 2 * FRACUNIT,
    height = 4 * FRACUNIT,
    flags = MF_NOGRAVITY | MF_NOCLIP
}

freeslot("SPR_RBXC", "SPR_RBXS", "SPR_RBXT")
freeslot("MT_SA2REDBOX", "S_SA2REDBOX")

states[S_SA2REDBOX] = {
	sprite = SPR_NULL,
    frame = A,
	tics = -1,
	nextstate = S_SA2REDBOX
}

mobjinfo[MT_SA2REDBOX] = {
	--$Name Red Crate
	--$Category SA2:Blast Objects
	--$Sprite RBXSA0
	--$arg0 Scaling Numerator
	--$arg1 Scaling Denominator
	doomednum = 6350,
    spawnstate = S_SA2REDBOX,
    radius = 64 * FRACUNIT,
    height = 128 * FRACUNIT,
    flags = MF_SOLID
}

freeslot("MT_SA2REDFACE", "S_SA2REDFACE")

states[S_SA2REDFACE] = {
	sprite = SPR_RBXS,
    frame = A,
	tics = -1,
	nextstate = S_SA2REDFACE
}

mobjinfo[MT_SA2REDFACE] = {
    spawnstate = S_SA2REDFACE,
    radius = 2 * FRACUNIT,
    height = 4 * FRACUNIT,
    flags = MF_NOGRAVITY | MF_NOCLIP
}

-- Spawn the six faces around a cube!
local function spawnCubeFaces(mo)
	
	local faceobject
	if mo.type == MT_SA2WOODBOX then faceobject = MT_SA2WOODFACE end
	if mo.type == MT_SA2METALBOX then faceobject = MT_SA2METALFACE end
	if mo.type == MT_SA2CHAOBOX then faceobject = MT_SA2CHAOFACE end
	if mo.type == MT_SA2STEELBOX then faceobject = MT_SA2STEELFACE end
	if mo.type == MT_SA2REDBOX then faceobject = MT_SA2REDFACE end
	
	local frontface = P_SpawnMobjFromMobj(mo, mo.radius, 0, 0, faceobject)
	frontface.prvar1 = 0
	frontface.prvar2 = mo.radius
	frontface.prangle = ANGLE_90
	frontface.frame = $ | FF_PAPERSPRITE
	
	local backface = P_SpawnMobjFromMobj(mo, mo.radius, 0, 0, faceobject)
	backface.prvar1 = 0
	backface.prvar2 = -1 * mo.radius
	backface.prangle = ANGLE_90
	backface.frame = $ | FF_PAPERSPRITE
	
	local leftface = P_SpawnMobjFromMobj(mo, mo.radius, 0, 0, faceobject)
	leftface.prvar1 = 0
	leftface.prvar2 = -1 * mo.radius / FRACUNIT
	leftface.prangle = 0
	leftface.frame = $ | FF_PAPERSPRITE
	
	local rightface = P_SpawnMobjFromMobj(mo, mo.radius, 0, 0, faceobject)
	rightface.prvar1 = 0
	rightface.prvar2 = mo.radius / FRACUNIT
	rightface.prangle = 0
	rightface.frame = $ | FF_PAPERSPRITE
	
	local topface = P_SpawnMobjFromMobj(mo, mo.radius, 0, 0, faceobject)
	topface.prvar1 = mo.height -- Needs to come after the scaling?
	topface.prvar2 = -1 * mo.radius
	topface.prangle = 0
	topface.renderflags = $ | RF_FLOORSPRITE | RF_NOSPLATBILLBOARD

	local bottomface = P_SpawnMobjFromMobj(mo, mo.radius, 0, 0, faceobject)
	bottomface.prvar1 = 0
	bottomface.prvar2 = -1 * mo.radius
	bottomface.prangle = 0
	bottomface.renderflags = $ | RF_FLOORSPRITE | RF_NOSPLATBILLBOARD
	
	mo.cubefaces = { frontface, backface, leftface, rightface, topface, bottomface }
	for i = 1, 6 do
		if mo.cubefaces[i] then mo.cubefaces[i].target = mo end
	end
	
end

addHook("MobjSpawn", spawnCubeFaces, MT_SA2WOODBOX)
addHook("MobjSpawn", spawnCubeFaces, MT_SA2METALBOX)
addHook("MobjSpawn", spawnCubeFaces, MT_SA2CHAOBOX)
addHook("MobjSpawn", spawnCubeFaces, MT_SA2STEELBOX)
addHook("MobjSpawn", spawnCubeFaces, MT_SA2REDBOX)

-- Scale a crate based on UDMF arguments
local function cubeScaling(mo)
	if mo.spawnpoint.args[0] and mo.spawnpoint.args[1] then
		mo.scale = (FRACUNIT * mo.spawnpoint.args[0]) / mo.spawnpoint.args[1]
	end
	if not mo.spawnpoint.args[0] and not mo.spawnpoint.args[1] then
		mo.scale = (FRACUNIT * 3) / 4
	end
end

addHook("MapThingSpawn", cubeScaling, MT_SA2WOODBOX)
addHook("MapThingSpawn", cubeScaling, MT_SA2METALBOX)
addHook("MapThingSpawn", cubeScaling, MT_SA2CHAOBOX)
addHook("MapThingSpawn", cubeScaling, MT_SA2STEELBOX)
addHook("MapThingSpawn", cubeScaling, MT_SA2REDBOX)

-- Make the cube faces follow the main cube object
local function cubeFaceThinker(mo)

	-- Stop existing if the main object doesn't exist
	if not (mo.target and mo.target.valid) then
		P_RemoveMobj(mo)
		return
	end
	
	-- If the source block is moving, enable thinker
	if mo.target.momz == 0 then
		-- Otherwise only run thinker twice a second
		if leveltime % (TICRATE / 2) != 0 then
			return
		end
		/*
		-- Or disable entirely if the disable function is on
		if mo.target.spawnpoint and mo.target.spawnpoint.args[2] then
			if leveltime > 0 then
				return
			end
		end
		*/
	end
	
	-- Follow the main object!
	A_CapeChase(mo, mo.prvar1, mo.prvar2)
	mo.angle = mo.target.angle + mo.prangle
	mo.z = mo.target.z + mo.prvar1
	
	-- Scale with the object!
	mo.scale = mo.target.scale
	if mo.renderflags and mo.prvar1
	and (mo.renderflags & RF_FLOORSPRITE) and mo.prvar1 != 0 then
		mo.prvar1 = mo.target.height
	end
end

addHook("MobjThinker", cubeFaceThinker, MT_SA2WOODFACE)
addHook("MobjThinker", cubeFaceThinker, MT_SA2METALFACE)
addHook("MobjThinker", cubeFaceThinker, MT_SA2CHAOFACE)
addHook("MobjThinker", cubeFaceThinker, MT_SA2STEELFACE)
addHook("MobjThinker", cubeFaceThinker, MT_SA2REDFACE)

--HardBox objects, not destructible by bounce attacks.
local HARDBOX = {}
HARDBOX[MT_SA2STEELFACE] = true
HARDBOX[MT_SA2REDFACE] = true
HARDBOX[MT_SA2STEELBOX] = true
HARDBOX[MT_SA2REDBOX] = true

-- Are these two objects colliding on the z-axis? (Also takes attacks into account)
local function zCollideAttacks(thing, tmthing)
	local p = tmthing.player
	if tmthing.z == thing.z then return true end
	if tmthing.z > thing.z then
		-- (this feels like this isn't compatible with gravflip but i'll deal with that later lol)
		if (tmthing.momz < 0) and p and ((p.powers[pw_strong] & STR_FLOOR)
		or p.sa2bouncevalue == 1) and not (HARDBOX[thing.type] == true) then
			return (thing.z + thing.height) > (tmthing.z + tmthing.momz)
		else
			return (thing.z + thing.height) > tmthing.z
		end
	end
	if tmthing.z < thing.z then
		if (tmthing.momz > 0) and p and (p.powers[pw_strong] & STR_CEILING) then
			return (tmthing.z + tmthing.height + tmthing.momz) > thing.z
		else
			return (tmthing.z + tmthing.height) > thing.z
		end	
	end
end

freeslot("S_PLAY_SLIDE", "S_PLAY_BOOSTRUN", "S_PLAY_AIRBOOST")
freeslot("S_MARINE_SWIPE", "S_MARINE_FLIP", "S_MARINE_FLIP2")

-- Can player destroy an object? (Like a crate)
local function destroyObjectNormal(p)
	if not (p and p.valid) then return end
	local tempCrawla = P_SpawnMobj(0, 0, FRACUNIT, MT_BLUECRAWLA)
	local returnvalue = P_PlayerCanDamage(p, tempCrawla)
	P_RemoveMobj(tempCrawla)
	return returnvalue and P_IsObjectOnGround(p.mo)
end

-- Handle objects colliding with a cube
local function cubeCollision(thing, tmthing)
	if thing and thing.valid
	and tmthing and tmthing.valid
	and zCollideAttacks(thing, tmthing) then
		
		-- THIS ENTIRE CODE BLOCK MIGHT BE FUCKED I NEED TO PARSE THROUGH IT HOLD ON
		
		-- If a player collides with the box
		local p = tmthing.player
		if p and p.valid then
		
			local ATK_TYPE = 0
			
			if (tmthing.momz < 0)
			and ((p.powers[pw_strong] & STR_FLOOR) or p.sa2bouncevalue == 1)
			and not (HARDBOX[thing.type] == true) then
				tmthing.momz = $ / 2 -- ???
				ATK_TYPE = 1 --Destroys non-steel crates, then bounces.
			elseif destroyObjectNormal(p)
				ATK_TYPE = 2 -- Normal crate destruction
			end
			
			if ATK_TYPE != 0 then
				if ATK_TYPE == 1 then
					tmthing.eflags = $ | MFE_JUSTHITFLOOR
					--Let the Bounce Attack auto-bounce.
					if p.yusonictable and p.yusonictable.bouncestate == 1
					and tmthing.skin == "adventuresonic" then
						tmthing.YU_ForceBounce = true
						YuBounce(p, tmthing, p.yusonictable)
					elseif p.sa2bouncevalue == 1 then
						p.sa2bouncevalue = 3
					end
				else --Slight slowdown.
					tmthing.momx = ($ * 6) / 7
					tmthing.momy = ($ * 6) / 7
				end
				if not HARDBOX[thing.type] == true then
					local particle = P_SpawnMobjFromMobj(thing, 0, 0, thing.height / 2, MT_DUST)
					particle.scale = FixedDiv(thing.radius, 12 * FRACUNIT)
					P_AddPlayerScore(tmthing.player, 50)
					S_StartSound(tmthing, sfx_wbreak)
					P_RemoveMobj(thing)
				end
			elseif thing.z == p.mo.z then
				local x1 = thing.x - thing.radius - p.mo.radius
				local x2 = thing.x + thing.radius + p.mo.radius
				local y1 = thing.y - thing.radius - p.mo.radius
				local y2 = thing.y + thing.radius + p.mo.radius
				if x1 < p.mo.x and p.mo.x < x2
				and y1 < p.mo.y and p.mo.y < y2 then
					return false
				end
			end
			
		end
		
		-- If a cork collides with the box
		if (thing and thing.valid and tmthing and tmthing.valid)
		and (tmthing.type == MT_CORK or tmthing.type == MT_LHRT or tmthing.type == MT_TORPEDO)
		and (tmthing.target and tmthing.target.player) then
		
			if not ((thing.type == MT_SA2STEELBOX) or (thing.type == MT_SA2REDBOX)) then
				local particle = P_SpawnMobjFromMobj(thing, 0, 0, thing.height / 2, MT_DUST)
				particle.scale = FixedDiv(thing.radius, 12 * FRACUNIT)
				P_AddPlayerScore(tmthing.target.player, 50)
				S_StartSound(tmthing, sfx_wbreak)
				P_RemoveMobj(thing)
			end
			
			tmthing.momx, tmthing.momy, tmthing.momz = 0, 0, 0
			P_KillMobj(tmthing)
			return
		end
		
		-- If a box collides with the box
		if ((tmthing.type == MT_SA2WOODBOX) or (tmthing.type == MT_SA2METALBOX) or
			(tmthing.type == MT_SA2CHAOBOX) or (tmthing.type == MT_SA2STEELBOX)
			or (tmthing.type == MT_SA2REDBOX)) and
		    (tmthing.z > thing.z) then
			tmthing.momz = 0
			return
		end
	end
	
	-- Player collision step-up
	if thing and thing.valid
	and tmthing and tmthing.valid
	and tmthing.player then
		local theight = thing.z + thing.height
		local bheight = theight - FixedMul(28 * FRACUNIT, tmthing.scale)
		if tmthing.z < theight and tmthing.z > bheight and tmthing.momz > 0 then
			tmthing.z = theight
			return
		end
	end
end

addHook("MobjCollide", cubeCollision, MT_SA2WOODBOX)
addHook("MobjCollide", cubeCollision, MT_SA2METALBOX)
addHook("MobjCollide", cubeCollision, MT_SA2CHAOBOX)
addHook("MobjCollide", cubeCollision, MT_SA2STEELBOX)
addHook("MobjCollide", cubeCollision, MT_SA2REDBOX)

freeslot("MT_CHAOKEY", "S_CHAOKEY", "SPR_CKEY")

states[S_CHAOKEY] = {
	sprite = SPR_CKEY,
    frame = A,
	tics = -1,
	nextstate = S_CHAOKEY
}

mobjinfo[MT_CHAOKEY] = {
	--$Name SA2 Chao Key
	--$Category SA2:Blast Objects
	--$Sprite CKEYA0
	doomednum = 6507,
    spawnstate = S_CHAOKEY,
    radius = 16 * FRACUNIT,
    height = 64 * FRACUNIT,
    flags = MF_SPECIAL | MF_NOGRAVITY
}

-- What happens when you touch a Chao Key?
local function touchKey(special, toucher)
	if toucher.player.bot then return end -- No bots!
	if not (toucher.player and toucher.player.valid -- Valid player?
	and toucher.player.playerstate == PST_LIVE) then return end
	if special and special.valid then
		P_SpawnMobjFromMobj(special, 0, 0, 8 * FRACUNIT, MT_SPARK)
		S_StartSound(toucher, sfx_ncitem)
		-- if token == 0 then token = 1 end
		-- FUCK THIS SHIT it's SO fucking finicky
		-- i'm just gonna make a COMPLETELY custom token system istg
	end
end

addHook("TouchSpecial", touchKey, MT_CHAOKEY)

-- Spawn Chao Key/Emerald Token inside Chao Crates
local function spawnKey(mo)
	if mo and mo.valid then
		P_SpawnMobjFromMobj(mo, 0, 0, 16 * FRACUNIT, MT_CHAOKEY)
	end
end

addHook("MobjSpawn", spawnKey, MT_SA2CHAOBOX)