-- Script to freeze the player/timer on map load, to account for Styles lag

-- Set values on player spawn
local function setSpawnValues(p)
    if p and p.valid then
        p.sa2savex = p.mo.x
        p.sa2savey = p.mo.y
        p.sa2savez = p.mo.z
    end
end

addHook("PlayerSpawn", setSpawnValues)

-- Freeze timer/player, and force player to regress to player spawn values
local function freezeMapStart(p)
	if gametype == GT_RACE then return end
    local threshold = (3 * TICRATE) / 2 -- Wait 1.5 seconds before starting level
    if p and p.valid and leveltime < threshold then
		if p.sa2savex != nil and p.sa2savey != nil and p.sa2savez != nil then
			p.sa2savex = p.mo.x
			p.sa2savey = p.mo.y
			p.sa2savez = p.mo.z
		end
		P_SetOrigin(p.mo, p.sa2savex, p.sa2savey, p.sa2savez)
        p.pflags = $ | PF_FULLSTASIS
		p.mo.momx = 0
		p.mo.momy = 0
		P_SetObjectMomZ(p.mo, 0)
        S_StopMusic(p)
		stoppedclock = true
    elseif leveltime == threshold then
        S_ChangeMusic(mapheaderinfo[gamemap].musname)
		stoppedclock = false
		P_ResetPlayer(p)
	elseif not ((p.pflags & PF_FINISHED) or p.exiting > 0
	or p.playerstate != PST_LIVE) then
		p.realtime = $ - threshold
    end
end

addHook("PlayerThink", freezeMapStart)

-- Note: Surprisingly, the only thing this breaks because of this
-- is the Styles checkpoint timer, but I patched that up

-- Freeze player when falling from the sky
local function freezeFalling(p)
	if gametype == GT_RACE then return end
	if p and p.valid and mapheaderinfo[gamemap].lvlttl == "City Escape"
	and p.realtime < ((9 * TICRATE) / 4) then
		p.pflags = $ | PF_FULLSTASIS
	end
end

addHook("PlayerThink", freezeFalling)