-- SA2Blast Scripts

dofile("Abilities/abilities.lua")
dofile("Abilities/spamdash.lua")
dofile("Abilities/bounce.lua")
dofile("Abilities/saltfang.lua")

dofile("Levels/cityescape.lua")
dofile("Levels/prisonlane.lua")
dofile("Levels/metalharbor.lua")
dofile("Levels/greenforest.lua")
dofile("Levels/pumpkinhill.lua")
dofile("Levels/drylagoon.lua")
dofile("Levels/sandocean.lua")
dofile("Levels/radicalhighway.lua")

dofile("Misc/misc.lua")
dofile("Misc/crates.lua")
dofile("Misc/hunt.lua")
dofile("Misc/monitors.lua")
dofile("Misc/allchars_sp.lua")
dofile("Misc/freeze.lua")
dofile("Misc/big.lua")

-- Shadow v1.3

dofile("Assets/Shadow-v1.3/PBT3.lua")
dofile("Assets/Shadow-v1.3/SHADOW-CHASSIS.lua")
dofile("Assets/Shadow-v1.3/SHADOW-CONFIG.lua")
dofile("Assets/Shadow-v1.3/SHADOW-MONITOR.lua")
dofile("Assets/Shadow-v1.3/SHADOW-BATTLE.lua")
dofile("Assets/Shadow-v1.3/SHADOW-MAIN.lua")
dofile("Assets/Shadow-v1.3/SHADOW-MOTOR.lua")
dofile("Assets/Shadow-v1.3/SHADOW-SKATECOLOR.lua")

-- EggPackRE v2.6

dofile("Assets/EggPackRE-v2.6/LoadScripts.lua")

-- Rouge v3.1

dofile("Assets/Rouge-v3.1/bombs.lua")
dofile("Assets/Rouge-v3.1/slide.lua")
dofile("Assets/Rouge-v3.1/sounds.lua")

-- JanaTools

dofile("Assets/JanaTools/DASH.lua")
dofile("Assets/JanaTools/DRNG.lua")
dofile("Assets/JanaTools/DRMP.lua")
dofile("Assets/JanaTools/PULY.lua")
dofile("Assets/JanaTools/jtedits.lua")

-- GSGrindRails SAT2032

dofile("Assets/GSGrindRails-SAT2032/LUA_FreeSlots")
dofile("Assets/GSGrindRails-SAT2032/LUA_SETUP")
dofile("Assets/GSGrindRails-SAT2032/LUA_RAILTYPES")
dofile("Assets/GSGrindRails-SAT2032/LUA_LOOPTYPES")
dofile("Assets/GSGrindRails-SAT2032/LUA_CUSTOMCHARS")
dofile("Assets/GSGrindRails-SAT2032/LUA_AdventureSonic--------")
dofile("Assets/GSGrindRails-SAT2032/LUA_MAINRAIL")
dofile("Assets/GSGrindRails-SAT2032/LUA_MOBJFUNC")
dofile("Assets/GSGrindRails-SAT2032/LUA_GRINDMOBJ")
dofile("Assets/GSGrindRails-SAT2032/LUA_PLAYER")
dofile("Assets/GSGrindRails-SAT2032/LUA_CAMERA")
dofile("Assets/GSGrindRails-SAT2032/LUA_DECOR------------------")
dofile("Assets/GSGrindRails-SAT2032/LUA_COLLIDE")
dofile("Assets/GSGrindRails-SAT2032/LUA_RAILGFX")
dofile("Assets/GSGrindRails-SAT2032/LUA_MENU-HUD")
dofile("Assets/GSGrindRails-SAT2032/LUA_PREPOST")
dofile("Assets/GSGrindRails-SAT2032/LUA_Hooks")

-- GunTroops v0.6

dofile("Assets/GunTroops-v0.6/LUA_GUN_SETUP")
dofile("Assets/GunTroops-v0.6/LUA_GUN_FREESLOTS")
dofile("Assets/GunTroops-v0.6/LUA_GUN-FUNCTIONS")
dofile("Assets/GunTroops-v0.6/LUA_GUN-MAIN")
dofile("Assets/GunTroops-v0.6/LUA_GUN-BEETLE")
dofile("Assets/GunTroops-v0.6/LUA_GUN-GFX")
dofile("Assets/GunTroops-v0.6/LUA_GUN-AUTOFRAME")
dofile("Assets/GunTroops-v0.6/LUA_GUN_MOBJS")
dofile("Assets/GunTroops-v0.6/LUA_GUN-FUNCTIONS")
dofile("Assets/GunTroops-v0.6/resize.lua")
dofile("Assets/GunTroops-v0.6/ZONEBUILDER/LUA-UDMF")
dofile("Assets/GunTroops-v0.6/ZONEBUILDER/LUA-BINA")

-- StarBlastCombo-v6.0

dofile("Assets/StarBlastCombo-v6.0/sb_scoringsystem.lua")
dofile("Assets/StarBlastCombo-v6.0/sb_resultscreen_back.lua")
dofile("Assets/StarBlastCombo-v6.0/sb_miscfunctions.lua")

-- Adventure Style v3.080

local gameString = "DC"

local packVersion = '3.080'
rawset(_G, "Style_AdventureVersion", 3080)
rawset(_G, "Style_Pack_Active", true)

local packType = '[Adventure Style '..packVersion..'] '
local version = '2.2.14'

--[[
	Sonic Adventure Stylized Pack for SRB2
	@ Contributors: Skydusk, Demnyx
]]

assert((VERSION == 202), packType.."Mod doesn't support this version of SRB2")
assert((SUBVERSION > 13), packType.."Mod requires features from "..version.."+")

if not tbsrequire then
	local cache_lib = {}

	rawset(_G, "tbsrequire", function(path)
		local path = 'Styles/'.. path .. ".lua" -- CHANGED
		if cache_lib[path] then
			return cache_lib[path]
		else
			local func, err = loadfile(path)
			if not func then
				error("error loading module '"..path.."': "..err)
			else
				cache_lib[path] = func()
				return cache_lib[path]
			end
		end
	end)

	rawset(_G, "tbslibrary", function(path)
		return tbsrequire("libs/"..path)
	end)
end

local function iterator_n(array, n) if n < #array then n = $+1 return n, array[n] end end
local function iterator(array) return iterator_n, array, 0 end

local function macro_dofile(prefix, ...)
	local array = {...}
	for _,use in iterator(array) do
		dofile('Styles/'.. prefix..'_'..use) -- CHANGED
	end
end

if VERSION == 202 and SUBVERSION > 13 and not Style_DimpsVersion and not Style_ClassicVersion then
	local start_metric = getTimeMicros()
	print(packType.."Loading")

	-- sal's library
	dofile('Styles/'.. "libs/sal_lib-customhud-v2-1.lua") -- CHANGED

	macro_dofile(gameString, "main.lua")

	macro_dofile("entities/"..gameString,
		"objects_custom.lua",

		"models_common.lua",
		"models_itembox.lua",
		"models_checkpoint.lua",
		"models_shields.lua") -- , -- CHANGED
		-- "flickies.lua") -- CHANGED

	macro_dofile(gameString, "game.lua")

	macro_dofile("hud/"..gameString,
		"user_game.lua",
		"user_inter.lua",
		"user_mics.lua")

	macro_dofile(gameString, "save.lua")

	print(packType.."Mod loaded in "..(getTimeMicros()-start_metric).." ms")
elseif Style_DimpsVersion or Style_ClassicVersion then
	-- Notify 'em
	local function ErrorPack_Notification(v)
		v.drawFill(0, 95, 320, 30, 38)
		v.drawString(160, 100, "DIFFERENT STYLE MOD DETECTED, ADVENTURE STYLE WON'T BE LOADED.", V_ORANGEMAP, "thin-center")
		v.drawString(160, 110, "PLEASE RESET THE GAME AND LOAD ONLY ONE STYLE PER SESSION.", 0, "thin-center")
	end

	hud.add(ErrorPack_Notification, "title")
	hud.add(ErrorPack_Notification, "game")
else
	-- Notify 'em
	local function MisVersion_Notification(v)
		v.drawFill(0, 95, 320, 30, 38)
		v.drawString(160, 100, "ADVENTURE STYLE WON'T BE LOADED IN THIS VERSION OF SRB2", V_ORANGEMAP, "thin-center")
		v.drawString(160, 110, "PLEASE DOWNLOAD 2.2.14+ or Nighty Build of SRB2", 0, "thin-center")
	end

	hud.add(MisVersion_Notification, "title")
	hud.add(MisVersion_Notification, "game")
end

-- StarBlastCombo-v6.0 (Ordering to overlap Styles)

dofile("Assets/StarBlastCombo-v6.0/sb_resultscreen_front.lua")